BeerOverflow/BeerOverflow.Web/Controllers/BeersController.cs
using BeerOverflow.Services.Contracts;
using BeerOverflow.Services.DTOs;
using BeerOverflow.Web.Mappers;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using System.Linq;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Controllers
{
    public class BeersController : Controller
    {
        private readonly IBeerService _beerService;
        private readonly IStyleService _styleService;
        private readonly IBreweryService _breweryService;
        private readonly ICountryService _countryService;
        private readonly IReviewService _reviewService;
        private readonly IRatingService _ratingService;

        public BeersController(IBeerService beerService, IStyleService styleService,
            IBreweryService breweryService, ICountryService countryService, IReviewService reviewService,
            IRatingService ratingService)
        {
            _beerService = beerService;
            _styleService = styleService;
            _breweryService = breweryService;
            _countryService = countryService;
            _reviewService = reviewService;
            _ratingService = ratingService;
        }

        public async Task<ActionResult> Index(string filterBy, string filter, string sortString = "", int page = 1, string search = "")
        {
            ViewData["Styles"] = (await _styleService.GetMany()).Select(x => x.Name);
            ViewData["Breweries"] = (await _breweryService.GetMany()).Select(x => x.Name);
            ViewData["Countries"] = (await _countryService.GetMany()).Select(x => x.Name);

            return sortString switch
            {
                "name" => View((await _beerService.GetMany(filterBy, sortString, filterValue: filter, page: page, searchQuery:search)
                    ).Select(x => x.ToViewModel())),

                "country" => View((await _beerService.GetMany(filterBy, sortString, filterValue: filter, page: page, searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                "abv-low" => View((await _beerService.GetMany(filterBy, "abv", filterValue: filter, page: page, searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                "abv-high" => View((await _beerService.GetMany(filterBy, "abv", filterValue: filter, page: page, order: "desc", searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                "rating-low" => View((await _beerService.GetMany(filterBy, "rating", filterValue: filter, page: page, searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                "rating-high" => View((await _beerService.GetMany(filterBy, "rating", filterValue: filter, page: page, order: "desc", searchQuery: search)
                    ).Select(x => x.ToViewModel())),

                _ => View((await _beerService.GetMany(filterBy, filterValue: filter, page: page, searchQuery: search)
                    ).Select(x => x.ToViewModel())),
            };
        }

        public async Task<ActionResult> Details(int id)
        {
            var beer = await _beerService.Get(id);
            return View(beer.ToViewModel());
        }

        public async Task<ActionResult> Create()
        {
            ViewData["StyleID"] = new SelectList(await _styleService.GetMany(), "ID", "Name");
            ViewData["BreweryID"] = new SelectList(await _breweryService.GetMany(), "ID", "Name");
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Create(BeerDTO beerDTO)
        {
            if (ModelState.IsValid)
            {
                try
                {
                    await _beerService.Create(beerDTO);
                }
                catch
                {
                    return RedirectToAction(nameof(Index));
                }
            }

            return RedirectToAction(nameof(Index));
        }

        [Authorize(Roles = "Admin")]
        public async Task<ActionResult> Edit(int id)
        {
            ViewData["StyleID"] = new SelectList(await _styleService.GetMany(), "ID", "Name");
            ViewData["BreweryID"] = new SelectList(await _breweryService.GetMany(), "ID", "Name");

            var beer = await _beerService.Get(id);
            return View(beer);
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(int id, BeerDTO beerDTO)
        {
            try
            {
                await _beerService.Update(id, beerDTO);
                return Redirect($"/Beers/Details/{id}");
            }
            catch
            {
                return View();
            }
        }

        [HttpPost]
        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> Review(int userId, int beerId)
        {
            try
            {
                string body = Request.Form["reviewBody"];
                int rating = int.Parse(Request.Form["userRating"]);
                await _reviewService.Create(userId, beerId, body);
                await _ratingService.Create(new RatingDTO { BeerID = beerId, UserID = userId, Value = rating });
            }
            catch
            {
            }

            return Redirect($"Details/{beerId}");
        }

        [HttpPost]
        [Authorize(Roles = "User, Admin")]
        public async Task<IActionResult> Like(int reviewId, int beerId)
        {
            try
            {
                await _reviewService.Like(reviewId);
            }
            catch
            {
            }

            return Redirect($"Details/{beerId}");
        }

        [Authorize(Roles = "Admin")]
        public ActionResult Delete(int id)
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Admin")]
        [ValidateAntiForgeryToken]
        public ActionResult Delete(int id, IFormCollection collection)
        {
            try
            {
                return RedirectToAction(nameof(Index));
            }
            catch
            {
                return View();
            }
        }
    }
}

BeerOverflow/BeerOverflow.Web/Controllers/DrankListController.cs
using BeerOverflow.Services.Contracts;
using BeerOverflow.Services.DTOs;
using BeerOverflow.Web.Mappers;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Controllers
{
    [Authorize(Roles = "User, Admin")]
    public class DrankListController : Controller
    {
        private readonly IDrankListService _drankListService;

        public DrankListController(IDrankListService drankListService)
        {
            _drankListService = drankListService;
        }

        // GET: DrankListController
        public async Task<ActionResult> Index()
        {
            var userId = User.FindFirstValue(ClaimTypes.NameIdentifier);
            var drankListBeersDTO = await _drankListService.GetAllBeerFromUserDrankList(int.Parse(userId));
            var drankListBeersViewModels = drankListBeersDTO.Select(dto => dto.ToViewModel()).ToList();

            return View(drankListBeersViewModels);
        }

        // POST: DrankListController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Add(DrankListDTO model)
        {
            try
            {
                model.UserID = int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));

                if (!_drankListService.CheckBeerInUserDrankList(model.UserID, model.BeerID))
                {
                    await _drankListService.AddBeerToUserDrankList(model.UserID, model.BeerID);
                }
            }
            catch
            {
            }

            return RedirectToAction("Index");
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Remove(DrankListDTO model)
        {
            try
            {
                var userId = int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));
                var result = await _drankListService.DeleteBeerOfUserDrankList(userId, model.BeerID);
            }
            catch
            {
            }

            return RedirectToAction("Index");
        }
    }
}

BeerOverflow/BeerOverflow.Web/Controllers/HomeController.cs
using BeerOverflow.Services.Contracts;
using BeerOverflow.Web.Mappers;
using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Controllers
{
    public class HomeController : Controller
    {
        private readonly IBeerService _beerService;
        private readonly IRatingService _ratingService;

        public HomeController(IBeerService beerService, IRatingService ratingService)
        {
            _beerService = beerService;
            _ratingService = ratingService;
        }

        public async Task<ActionResult> Index()
        {
            var beers = await _beerService.GetMany();

            return View(
                beers.Select(x => x.ToViewModel())
                     .OrderByDescending(x => GetRatingComparator(x.Id))
                     .Take(6));
        }

        private double GetRatingComparator(int id)
        {
            Task<double> result = _ratingService.Average(id, true);
            result.Wait();

            return result.Result;
        }
    }
}

BeerOverflow/BeerOverflow.Web/Controllers/WishListController.cs
using BeerOverflow.Services.Contracts;
using BeerOverflow.Services.DTOs;
using BeerOverflow.Web.Mappers;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System.Linq;
using System.Security.Claims;
using System.Threading.Tasks;

namespace BeerOverflow.Web.Controllers
{
    [Authorize(Roles = "User, Admin")]
    public class WishListController : Controller
    {
        private readonly IWishListService _wishListService;

        public WishListController(IWishListService wishListService)
        {
            _wishListService = wishListService;
        }
        // GET: WishListControll
        public async Task<ActionResult> Index()
        {
            var userId = User.FindFirstValue(ClaimTypes.NameIdentifier);
            var wishListBeersDTO = await _wishListService.GetAllBeerFromUserWishList(int.Parse(userId), null, null);
            var wishListBeersViewModels = wishListBeersDTO.Select(dto => dto.ToViewModel()).ToList();

            return View(wishListBeersViewModels);
        }

        // POST: WishListControll/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Add(WishListDTO model)
        {
            try
            {
                model.UserID = int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));

                if (!_wishListService.CheckBeerInUserWishList(model.UserID, model.BeerID))
                {
                    await _wishListService.AddBeerToUserWishList(model);
                }
            }
            catch
            {
            }

            return RedirectToAction("Index");
        }

        // POST: WishListControll/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Remove(WishListDTO model)
        {
            try
            {
                var userId = int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));
                var result = await _wishListService.DeleteBeerFromUserWishList(userId, model.BeerID);
            }
            catch
            {
            }

            return RedirectToAction("Index");
        }
    }
}

BeerOverflow/BeerOverflow.Web/Views/Home/Index.cshtml
@model IEnumerable<BeerOverflow.Web.Models.BeerViewModel>
@{
    ViewData["Title"] = "Home";
}

<div class="container">
    <section class="py-5">
        <div class="container">
            <section class="hero pb-3 bg-cover bg-center d-flex align-items-center" style="background: url(@Url.Content("~/img/home/sitebanner.jpg"))">
                <div class="container py-5">
                    <div class="row px-4 px-lg-5">
                        <div class="col-lg-6">
                            <p class="text-muted small text-uppercase mb-2">The place to find beers</p>
                            <h1 class="h2 text-uppercase mb-3">Welcome to BeerOverflow</h1><a class="btn btn-dark" asp-controller="Beers" asp-action="Index">Browse beers</a>
                        </div>
                    </div>
                </div>
            </section>
            <!-- CATEGORIES SECTION-->
            <section class="pt-5">
                <header class="text-center">
                    <p class="small text-muted small text-uppercase mb-1">Take your time and</p>
                    <h2 class="h5 text-uppercase mb-4">Browse our categories</h2>
                </header>
                <div class="row">
                    <div class="col-md-4 mb-4 mb-md-0">
                        <a class="category-item" asp-controller="Beers" asp-action="Index"><img class="img-fluid" src="@Url.Content("~/img/home/beersbanner.jpg")" alt=""><strong class="category-item-title">Beers</strong></a>
                    </div>
                    <div class="col-md-4 mb-4 mb-md-0">
                        <a class="category-item mb-4" asp-controller="Countries" asp-action="Index"><img class="img-fluid" src="@Url.Content("~/img/home/countriesbanner.jpg")" alt=""><strong class="category-item-title">Countries</strong></a>
                        <a class="category-item" asp-controller="Styles" asp-action="Index"><img class="img-fluid" src="@Url.Content("~/img/home/stylesbanner.jpg")" alt=""><strong class="category-item-title">Styles</strong></a>
                    </div>
                    <div class="col-md-4">
                        <a class="category-item" asp-controller="Breweries" asp-action="Index"><img class="img-fluid" src="@Url.Content("~/img/home/breweriesbanner.jpg")" alt=""><strong class="category-item-title">Breweries</strong></a>
                    </div>
                </div>
            </section>
            <!-- Top rated beers-->
            <section class="py-5">
                <header class="text-center">
                    <p class="small text-muted small text-uppercase mb-1">Have a look at our</p>
                    <h2 class="h5 text-uppercase mb-4">Top rated beers</h2>
                </header>
                <div class="row">
                    <!-- Beer-->
                    @foreach (var item in Model)
                    {
                        <div class="col-lg-4 col-sm-6">
                            <div class="product text-center">
                                <div class="mb-3 position-relative">
                                    <div class="badge text-white badge-"></div><a class="d-block" href="Beers/Details/@item.Id"><img class="img-fluid w-100" src="@Url.Content($"~/img/beers/beer{item.Id}.jpg")" onerror='this.src="@Url.Content($"~/img/beers/defaultbeer.jpg")"'></a>
                                    <div class="product-overlay">
                                        <ul class="mb-0 list-inline">
                                            <li class="list-inline-item m-0 p-0">
                                                <form asp-action="Add" asp-controller="WishList" method="post">
                                                    <input type="hidden" name="BeerId" value="@item.Id" />
                                                    <button class="btn btn-sm btn-outline-dark" type="submit">
                                                        <i class="far fa-heart"></i>
                                                    </button>
                                                </form>
                                            </li>
                                            <li class="list-inline-item m-0 p-0"><a class="btn btn-sm btn-dark" href="Beers/Details/@item.Id">Details</a></li>
                                            <li class="list-inline-item mr-0">
                                                <form asp-action="Add" asp-controller="DrankList" method="post">
                                                    <input type="hidden" name="beerId" value="@item.Id" />
                                                    <button class="btn btn-sm btn-outline-dark" type="submit">
                                                        <i class="fas fa-beer"></i>
                                                    </button>
                                                </form>
                                            </li>
                                        </ul>
                                    </div>
                                </div>
                                <h6> <a class="reset-anchor" href="detail.html">@item.Name</a></h6>
                                <p class="small text-muted">@item.ABV</p>
                            </div>
                        </div>
                    }
                </div>
            </section>
        </div>
    </section>
</div>